#ifndef START_MENU_H
#define START_MENU_H

#include <apps.h> // ! !
#include <loader.h>
#include <ATI.h>
#include <paint.h>
#include <u.h>
#include <mem.h>
#include <utilities.h>
#include <func.h>
#include <res_def.h>
#include <charset_conv.h>
#include <obex_mgr.h>

#define  ELF_NAME				"MiniCommander"
#define  ELF_NAME_W			   L"MiniCommander"
#define  ELF_VER				"v0.6"
#define  ELF_VER_W			   L"v0.6"
#define  DEBUG_APP_NAME			ELF_NAME
#define  LOG_FILE  				L"file://b/"ELF_NAME".log"

#include <tadbg.h> 	// 

/*    .      */
typedef struct
{ 
    APPLICATION_T           apt; /*   ,   */
	UINT16					window; 			//   .
	UINT32					res; 				//    .
	UINT32       			entries_num;		// - 
	UINT32					entries_num_menu;	// -   
	UINT32                  prev_state;
	
} APP_MC_T;

/*   */
typedef enum
{
    MC_STATE_ANY, /* ANY-state   */
	MC_STATE_MAIN, //  .
	MC_STATE_EDIT, // -
	MC_STATE_NOTICE, // -.
	MC_STATE_VIEWER, // .
	MC_STATE_EDIT_PROPS, //  .
	MC_STATE_MENU, // .
    MC_STATE_MAX /*   */
} MC_STATES_T;


typedef enum
{
	MAIN, //  .
	HELP, // .
	VIEW_FILE, //  .
	EDIT_FILE, //  .
	COPY_FILE, //  .
	PASTE_FILE, //  .
	RENAME, //.
	CREATE_DIR, //  .
	CREATE_FILE, //  .
	DEL_DIR, //  .
	ZIP_BROWSER, // 
	ZIP_BROWSER_COPY, //  zip - .
	ZIP_BROWSER_PASTE, //   zip - .
	EDIT_ATTR, //  .
	MAIN_MENU, //   .
	FAST_MENU, //    *.
	OPEN_WITH, //  '  ...'  #.
	CHANGE_CP, //   .
	ABOUT //  ...
}STATES_T;

typedef enum{
    CODE_NULL=0,
    CODE_ANSI, //  
    CODE_UCS2_BE, // UTF-16Big Endian
	CODE_UTF8,
	CODE_UTF8_BOM // UTF-8  

}CODE_TYPE_T;


typedef struct
{
	WCHAR   	ini[128]; //   mc.ini
	WCHAR   	menu[128]; //   mc.menu
	WCHAR   	cfg[128];
	
	WCHAR   	*src_copy_name[24]; 
	WCHAR   	*src_copy_uri[24]; //   
	WCHAR   	*dst_copy_uri[24]; //  
	WCHAR   	zip_uri[256]; //    zip 
	WCHAR   	temp_uri[256]; //     zip 
	FILE        handle; //  
	UINT32      size; // 
	CODE_TYPE_T code_type; //  
	UINT32      cur_position; //    
	UINT32      page_size; // -   
	UINT32      s_page_size; //  -    
    UINT32      count_pages; // - 
    UINT32      num_page; // 
	WCHAR   	buffer[BUFFER_SIZE+1]; //   
    
} FILE_T;// 


typedef struct
{
	UINT32 		ev_code; 		//  	
	WCHAR  		temp_dir[128]; //     
	WCHAR       cur_folder1[272];  //  ,  1
	WCHAR       cur_folder2[272];  //   ,  2

} SETTING_T;// 


typedef struct
{
	WCHAR		name[128]; //  
	WCHAR		ext[16]; //
	UINT16		attrib;   // 
	BOOL		selected;
} FILEINFO; //   .   .

typedef struct
{
	WCHAR name[32]; 	// 
	WCHAR value[256];   // 
} LINE; //   -

typedef struct
{
	UINT16		item;
	UINT16		sel;
} EDIT;

typedef struct
{
	UINT32		prev;
	UINT32		select;
	UINT32		select1;
	UINT32		select2;
	UINT32		menu;
	UINT32		edit;
} ITEM;


typedef struct
{
	UINT32				Background;  
	UINT32				Lines;
	UINT32				Cursor;
	UINT32				Dir;
	UINT32				App;
	UINT32				Arc;
	UINT32				Pic;
	UINT32				Audio;
	UINT32				Sys;
	UINT32				Def;
} COLOR; // 

ldrElf* _start( WCHAR *uri, WCHAR *params );
static UINT32 startApp( EVENT_STACK_T *ev_st,  REG_ID_T reg_id,  UINT32 param2 );
static UINT32 destroyApp( EVENT_STACK_T *ev_st,  APPLICATION_T *app );

static UINT32 MainStateEnter( EVENT_STACK_T *ev_st,  APPLICATION_T *app,  ENTER_STATE_TYPE_T type );
static UINT32 EditStateEnter( EVENT_STACK_T *ev_st,  APPLICATION_T *app,  ENTER_STATE_TYPE_T type );
static UINT32 NoticeStateEnter( EVENT_STACK_T *ev_st,  APPLICATION_T *app,  ENTER_STATE_TYPE_T type );
static UINT32 ViewerStateEnter( EVENT_STACK_T *ev_st,  APPLICATION_T *app,  ENTER_STATE_TYPE_T type );
static UINT32 EditPropsEnter( EVENT_STACK_T *ev_st,  APPLICATION_T *app,  ENTER_STATE_TYPE_T type );
static UINT32 MenuStateEnter( EVENT_STACK_T *ev_st,  APPLICATION_T *app,  ENTER_STATE_TYPE_T type );

static UINT32 StateExit( EVENT_STACK_T *ev_st,  APPLICATION_T *app,  EXIT_STATE_TYPE_T type );

static UINT32 ListKeypress( EVENT_STACK_T * ev_st,  APPLICATION_T * app ); //     .
static UINT32 NoticeKeypress( EVENT_STACK_T * ev_st,  APPLICATION_T * app );
static UINT32 ViewerKeypress( EVENT_STACK_T * ev_st,  APPLICATION_T * app ); //    
static UINT32 EditKeypress( EVENT_STACK_T * ev_st,  APPLICATION_T * app ); //     .
static UINT32 MenuKeypress( EVENT_STACK_T * ev_st,  APPLICATION_T * app ); //    .

static UINT32 LoadSkin(void); 

static UINT32 Paint( EVENT_STACK_T *ev_st,  APPLICATION_T *app );
static UINT32 DrawLoadingScreen(WCHAR *text);
static UINT32 DrawMenu(UINT16 index, APPLICATION_T *app);
static UINT32 DrawMenu2(UINT16 index, APPLICATION_T *app);
static UINT32 DrawEditProps(UINT16 index); //   .
static UINT32 DrawViewer(void);

static UINT32 DrawList(APPLICATION_T *app);
static UINT32 DrawInfo(APPLICATION_T *app);

static UINT32 MakeContentFromFlie(void); // 
static UINT32 MakeContentAboutFlie(APPLICATION_T *app ); //   
static UINT32 SelectItemList( EVENT_STACK_T *ev_st,  APPLICATION_T *app ); //
static UINT32 SelectItemMenu( EVENT_STACK_T *ev_st,  APPLICATION_T *app );//  
static UINT32 SelectItemMenu2( EVENT_STACK_T *ev_st,  APPLICATION_T *app );//  main 
static UINT32 Save( EVENT_STACK_T *ev_st,  APPLICATION_T *app );

static UINT32 EditOk( EVENT_STACK_T *ev_st,  APPLICATION_T *app );
static UINT32 EditData( EVENT_STACK_T *ev_st,  APPLICATION_T *app );
static UINT32 EditCancel( EVENT_STACK_T *ev_st,  APPLICATION_T *app ); //  ""  
static UINT32 OpenFile(WCHAR *uri); //   extmgr.elf

static BOOL   IsRoot(void); 
static WCHAR* Language(UINT8 lng);
static void   TestMem(void); //   
static void   util_ul2u( UINT32 src, WCHAR * dst, int count );
static BOOL   cmpstr(WCHAR *str1, WCHAR *str2); //      

static UINT32 ReadSetting(void); //    
static UINT32 SaveSetting(APPLICATION_T *app); //   
static UINT32 Action( EVENT_STACK_T * ev_st,  APPLICATION_T *app );

static UINT32 FindFile( WCHAR *folder, WCHAR *filtr, APPLICATION_T *app); //  
static UINT32 UtilCopyFile(WCHAR *src, WCHAR *dst ); //   
static UINT32 UtilRDelDir(WCHAR *uri, WCHAR *filtr );//    
static UINT32 UtilRGetDirSize( WCHAR *uri );
static UINT32 UtilSetColForFile(UINT32 index);
static UINT32 UtilGetTotalSelectFiles(APPLICATION_T *app);
static UINT32 UtilEditAtt(WCHAR *uri, UINT16 attrib);

static UINT32 ZIP_ReadFileList(WCHAR * uri, APPLICATION_T *app);
static UINT32 ReadMenu(APPLICATION_T *app);

static UINT32 LoadBuffer(INT32 off_set); //  c   
static UINT32 SizePrevPage(WCHAR *str, UINT8 x, UINT8 y); //     
static UINT32 DrawTextInFullDisplay_(WCHAR *str, UINT8 x, UINT8 y); // 

#endif